/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive;

/**
 * Attachment with an Action.
 */
public interface ActionAttachment extends CertifiedAttachment {
	
	/**
	 * Returns the Action of this Attachment.
	 * @return the Action of this Attachment.
	 */
	public Action getAction();
	
	/**
	 * Returns the Exception throwed by the Action during its execution if any,
	 *   null elsewhere.
	 * @return the Exception throwed by the Action during its execution if any,
	 *   null elsewhere.
	 */
	public Exception getException();
}
