/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element;

/**
 * A RootElement is a ParentElement that can be saved as XML content.
 */
public interface RootElement extends ParentElement {
	
	/**
	 * Returns the Namespace count.
	 * @return the Namespace count.
	 */
	public int namespaceCount();
	
	/**
	 * Returns the Namespace with the given index.
	 * @param index the Namespace index : 0 to n-1.
	 * @return the Namespace with the given index.
	 */
	public Namespace getNamespace(int index);
	
	/**
	 * Adds a namespace.
	 * @param namespace a Namespace.
	 */
	public void addNamespace(Namespace namespace);
}
