/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import java.util.Comparator;

import org.xmloperator.reactive.Action;

//import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;
import org.xmloperator.reactive.element.RWParentElement;
import org.xmloperator.reactive.element.ElementWritingAccess;

import org.xmloperator.reactive.element.action.ElementActionImpl;

/**
 * Action of sorting the children of a ParentElement.
 */
public final class ChildrenSortAction extends ElementActionImpl {
	
	public final Comparator elementComparator;
	
	public ChildrenSortAction(ElementWritingAccess elementWritingAccess,
			ParentElement referenceElement, Comparator elementComparator,
			int status) {
		super(elementWritingAccess, referenceElement, status);
		this.elementComparator = elementComparator;
	}
	
	public boolean isChildrenSortAction() {
		return true;
	}

	///////////////////////////////
	// ElementAction implementation
	///////////////////////////////
	
	public ParentElement getTouchedParentElement() {
		return (ParentElement)this.referenceElement;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public boolean equals(Action action) {
		if (!(action instanceof ChildrenSortAction))
			return false;
		ChildrenSortAction otherAction = (ChildrenSortAction)action;
		return this.referenceElement == otherAction.referenceElement;
	}

	public void execute(long key) {
		RWParentElement rwParentElement =
			(RWParentElement)this.elementWritingAccess.rwElement(
				this.referenceElement, key);
		rwParentElement.sortChildren(this.elementComparator);
	}

	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append("sort");
		sb.append('(');
		sb.append(this.elementComparator);
		sb.append(')');
		return sb.toString();
	}
}
