/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import org.xmloperator.reactive.Action;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;
import org.xmloperator.reactive.element.RWElement;
import org.xmloperator.reactive.element.ElementWritingAccess;

import org.xmloperator.reactive.element.action.ElementActionImpl;

/**
 * Action of removing an Element.
 */
public final class ElementRemoveAction extends ElementActionImpl {
	
	public ElementRemoveAction(ElementWritingAccess elementWritingAccess,
			Element referenceElement, int status) {
		super(elementWritingAccess, referenceElement, status);
	}
	
	public boolean isElementRemoveAction() {
		return true;
	}

	///////////////////////////////
	// ElementAction implementation
	///////////////////////////////
	
	public ParentElement getTouchedParentElement() {
		return this.referenceElement.getParent();
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public boolean equals(Action action) {
		if (!(action instanceof ElementRemoveAction))
			return false;
		ElementRemoveAction otherAction = (ElementRemoveAction)action;
		return this.referenceElement == otherAction.referenceElement;
	}

	public void execute(long key) {
		RWElement rwElement =
			(RWElement)this.elementWritingAccess.rwElement(
				this.referenceElement, key);
		rwElement.remove();
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append("remove");
		return sb.toString();
	}
}
