/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.spec;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.TranslatableObject;

/**
 * An ElementSpecification determines if a given Element is conformant or
 *   not conformant to it.
 */
public interface ElementSpecification extends TranslatableObject {
	
	/**
	 * Returns true if the given Element is conformant to this specification,
	 *   false elsewhere.
	 * @param element an Element.
	 * @return true if the given Element is conformant to this specification,
	 *   false elsewhere.
	 */
	public boolean accepts(Element element);
}
