/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.spec;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.Rebuilder;
import org.xmloperator.reactive.element.TranslatableObject;

/**
 * Rebuilder of a RootElementSpecification.
 */
public final class RootElementSpecRebuilder implements Rebuilder {

	public RootElementSpecRebuilder() {
	}
	
	///////////////////////////
	// Rebuilder implementation
	///////////////////////////
	
	public void startElement(
			String namespaceURI,
			String localName,
			String rawName,
			Attributes atts)
			throws SAXException {
		throw new SAXException(new IllegalStateException());
	}

	public TranslatableObject endElement(
			String namespaceURI,
			String localName,
			String rawName)
			throws SAXException {
		if (namespaceURI != Element.REACTIVE_NAMESPACE
				|| !localName.equals("root"))
			throw new SAXException(new IllegalStateException());
		return RootElementSpecification.ROOT;
	}

	public void characters(char[] ch, int start, int length)
			throws SAXException {
		throw new SAXException(new IllegalStateException());
	}
}
