/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.facet.event;

import org.xmloperator.reactive.Event;

/**
 * BoolCondition corresponding to not occuring of a given base Event.
 */
public final class NegativeEventBoolCondition extends EventBoolConditionImpl {
	
	public NegativeEventBoolCondition(Event event) {
		super(event);
	}

	//////////////////////////
	// BoolNode implementation
	//////////////////////////
	
	public boolean isNegativeEvent() {
		return true;
	}

	public boolean containsNegativeEvent() {
		return true;
	}

	public BoolCondition restAfterEvent(Event event) {
		return event != this.event
			? (BoolCondition)this
			: FalseBoolCondition.FALSE;
	}

	public BoolCondition restAtEndOfInstant() {
		return TrueBoolCondition.TRUE;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return "!" + this.event.toString();
	}
}
