/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.facet.event;

import org.xmloperator.reactive.Event;

/**
 * BoolCondition corresponding to the occuring of a given base Event.
 */
public final class PositiveEventBoolCondition extends EventBoolConditionImpl {
	
	public PositiveEventBoolCondition(Event event) {
		super(event);
	}
	
	//////////////////////////
	// BoolNode implementation
	//////////////////////////
	
	public BoolCondition restAfterEvent(Event event) {
		return event != this.event
			? (BoolCondition)this
			: TrueBoolCondition.TRUE;
	}

	public BoolCondition restAtEndOfInstant() {
		return FalseBoolCondition.FALSE;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.event.toString();
	}
}
