/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

import org.xmloperator.reactive.Terms;

/**
 * Terms implementation.
 */
public final class TermsImpl implements Terms {
	
	private final Object[] terms;

	public TermsImpl(Object[] objects) {
		this.terms = new Object[objects.length];
		System.arraycopy(objects, 0, this.terms, 0, objects.length);
	}

	public TermsImpl(Object obj_0) {
		this.terms = new Object[] {obj_0};
	}
	
	public TermsImpl(Object obj_0, Object obj_1) {
		this.terms = new Object[] {obj_0, obj_1};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2) {
		this.terms = new Object[] {obj_0, obj_1, obj_2};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2, Object obj_3) {
		this.terms = new Object[] {obj_0, obj_1, obj_2, obj_3};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2, Object obj_3,
			Object obj_4) {
		this.terms = new Object[] {obj_0, obj_1, obj_2, obj_3, obj_4};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2, Object obj_3,
			Object obj_4, Object obj_5) {
		this.terms = new Object[] {obj_0, obj_1, obj_2, obj_3, obj_4, obj_5};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2, Object obj_3,
			Object obj_4, Object obj_5, Object obj_6) {
		this.terms = new Object[] {obj_0, obj_1, obj_2, obj_3, obj_4, obj_5,
				obj_6};
	}
	
	public TermsImpl(Object obj_0, Object obj_1, Object obj_2, Object obj_3,
			Object obj_4, Object obj_5, Object obj_6, Object obj_7) {
		this.terms = new Object[] {obj_0, obj_1, obj_2, obj_3, obj_4, obj_5,
				obj_6, obj_7};
	}
	
	void set(int index, Object obj) {
		this.terms[index] = obj;
	}

	///////////////////////
	// Terms implementation
	///////////////////////
	
	public int count() {
		return this.terms.length;
	}
	
	public Object get(int index) {
		return this.terms[index];
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append('(');
		for (int k = 0; k < this.terms.length; k++) {
			Object term = this.terms[k];
			if (k > 0)
				sb.append(',');
			if (term == null)
				sb.append("null");
			else if (term instanceof String) {
				sb.append("\"");
				sb.append(term);
				sb.append("\"");
			}
			else
				sb.append(term);
		}
		sb.append(')');
		return sb.toString();
	}
}
